## gitlab-ci-multi-runner 1.4.1+dfsg

=== Makefile ===
NAME ?= gitlab-ci-multi-runner
PACKAGE_NAME ?= $(NAME)
PACKAGE_CONFLICT ?= $(PACKAGE_NAME)-beta
REVISION := $(shell git rev-parse --short HEAD || echo unknown)
LAST_TAG := $(shell git describe --tags --abbrev=0)
COMMITS := $(shell echo `git log --oneline $(LAST_TAG)..HEAD | wc -l`)
VERSION := $(shell (cat VERSION || echo dev) | sed -e 's/^v//g')
BUILT := $(shell date +%Y-%m-%dT%H:%M:%S%:z)
ifneq ($(RELEASE),true)
    VERSION := $(shell echo $(VERSION)~beta.$(COMMITS).g$(REVISION))
endif
BRANCH := $(shell git show-ref | grep "$(REVISION)" | grep -v HEAD | awk '{print $$2}' | sed 's|refs/remotes/origin/||' | sed 's|refs/heads/||' | sort | head -n 1)
ITTERATION := $(shell date +%s)
PACKAGE_CLOUD ?= ayufan/gitlab-ci-multi-runner
PACKAGE_CLOUD_URL ?= https://packagecloud.io/
BUILD_PLATFORMS ?= -os '!netbsd' -os '!openbsd'
S3_UPLOAD_PATH ?= master
DEB_PLATFORMS ?= debian/wheezy debian/jessie debian/stretch debian/buster \
    ubuntu/precise ubuntu/trusty ubuntu/utopic ubuntu/vivid ubuntu/wily ubuntu/xenial \
    raspbian/wheezy raspbian/jessie raspbian/stretch raspbian/buster \
    linuxmint/petra linuxmint/qiana linuxmint/rebecca linuxmint/rafaela linuxmint/rosa
DEB_ARCHS ?= amd64 i386 arm armhf
RPM_PLATFORMS ?= el/6 el/7 \
    ol/6 ol/7 \
    fedora/20 fedora/21 fedora/22 fedora/23
RPM_ARCHS ?= x86_64 i686 arm armhf
COMMON_PACKAGE_NAMESPACE=$(shell go list ./common)
GO_LDFLAGS ?= -X $(COMMON_PACKAGE_NAMESPACE).NAME=$(PACKAGE_NAME) -X $(COMMON_PACKAGE_NAMESPACE).VERSION=$(VERSION) \
              -X $(COMMON_PACKAGE_NAMESPACE).REVISION=$(REVISION) -X $(COMMON_PACKAGE_NAMESPACE).BUILT=$(BUILT) \
              -X $(COMMON_PACKAGE_NAMESPACE).BRANCH=$(BRANCH)
GO_FILES ?= $(shell find . -name '*.go')
export GO15VENDOREXPERIMENT := 1
export CGO_ENABLED := 0

all: deps verify build

help:
	# Commands:
	# make all => deps verify build
	# make version - show information about current version
	#
	# Development commands:
	# make install - install the version suitable for your OS as gitlab-ci-multi-runner
	# make docker - build docker dependencies
	#
	# Testing commands:
	# make verify - run fmt, complexity, test and lint
	# make fmt - check source formatting
	# make test - run project tests
	# make lint - check project code style
	# make vet - examine code and report suspicious constructs
	# make complexity - check code complexity
	#
	# Deployment commands:
	# make deps - install all dependencies
	# make build - build project for all supported OSes
	# make package - package project using FPM
	# make packagecloud - send all packages to packagecloud
	# make packagecloud-yank - remove specific version from packagecloud

version: FORCE
	@echo Current version: $(VERSION)
	@echo Current iteration: $(ITTERATION)
	@echo Current revision: $(REVISION)
	@echo Current branch: $(BRANCH)
	@echo Build platforms: $(BUILD_PLATFORMS)
	@echo DEB platforms: $(DEB_PLATFORMS)
	@echo RPM platforms: $(RPM_PLATFORMS)
	bash -c 'echo TEST: ${GO15VENDOREXPERIMENT}'

verify: fmt vet lint complexity test

deps:
	# Installing dependencies...
	go get -u github.com/golang/lint/golint
	go get github.com/mitchellh/gox
	go get golang.org/x/tools/cmd/cover
	go get github.com/fzipp/gocyclo
	go get -u github.com/jteeuwen/go-bindata/...
	go install cmd/vet

out/docker/prebuilt-x86_64.tar.gz: $(GO_FILES)
	# Create directory
	mkdir -p out/docker

ifneq (, $(shell docker info))
	# Building gitlab-runner-helper
	gox -osarch=linux/amd64 \
		-ldflags "$(GO_LDFLAGS)" \
		-output="dockerfiles/build/gitlab-runner-helper" \
		./apps/gitlab-runner-helper

	# Build docker images
	docker build -t gitlab-runner-prebuilt-x86_64:$(REVISION) -f dockerfiles/build/Dockerfile.x86_64 dockerfiles/build
	-docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
	docker create --name=gitlab-runner-prebuilt-x86_64-$(REVISION) gitlab-runner-prebuilt-x86_64:$(REVISION) /bin/sh
	docker export -o out/docker/prebuilt-x86_64.tar gitlab-runner-prebuilt-x86_64-$(REVISION)
	docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
	gzip -f -9 out/docker/prebuilt-x86_64.tar
else
	$(warning =============================================)
	$(warning WARNING: downloading prebuilt docker images that will be embedded in gitlab-runner)
	$(warning WARNING: to use images compiled from your code install Docker Engine)
	$(warning WARNING: and remove out/docker/prebuilt-x86_64.tar.gz)
	$(warning =============================================)
	curl -o out/docker/prebuilt-x86_64.tar.gz \
		https://gitlab-ci-multi-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-x86_64.tar.gz
endif

out/docker/prebuilt-arm.tar.gz: $(GO_FILES)
	# Create directory
	mkdir -p out/docker

ifneq (, $(shell docker info))
	# Building gitlab-runner-helper
	gox -osarch=linux/arm \
		-ldflags "$(GO_LDFLAGS)" \
		-output="dockerfiles/build/gitlab-runner-helper" \
		./apps/gitlab-runner-helper

	# Build docker images
	docker build -t gitlab-runner-prebuilt-arm:$(REVISION) -f dockerfiles/build/Dockerfile.arm dockerfiles/build
	-docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
	docker create --name=gitlab-runner-prebuilt-arm-$(REVISION) gitlab-runner-prebuilt-arm:$(REVISION) /bin/sh
	docker export -o out/docker/prebuilt-arm.tar gitlab-runner-prebuilt-arm-$(REVISION)
	docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
	gzip -f -9 out/docker/prebuilt-arm.tar
else
	$(warning =============================================)
	$(warning WARNING: downloading prebuilt docker images that will be embedded in gitlab-runner)
	$(warning WARNING: to use images compiled from your code install Docker Engine)
	$(warning WARNING: and remove out/docker/prebuilt-arm.tar.gz)
	$(warning =============================================)
	curl -o out/docker/prebuilt-arm.tar.gz \
		https://gitlab-ci-multi-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-arm.tar.gz
endif

executors/docker/bindata.go: out/docker/prebuilt-x86_64.tar.gz out/docker/prebuilt-arm.tar.gz
	# Generating embedded data
	go-bindata \
		-pkg docker \
		-nocompress \
		-nomemcopy \
		-nometadata \
		-prefix out/docker/ \
		-o executors/docker/bindata.go \
		out/docker/prebuilt-x86_64.tar.gz \
		out/docker/prebuilt-arm.tar.gz

docker: executors/docker/bindata.go

build: executors/docker/bindata.go
	# Building $(NAME) in version $(VERSION) for $(BUILD_PLATFORMS)
	gox $(BUILD_PLATFORMS) \
		-ldflags "$(GO_LDFLAGS)" \
		-output="out/binaries/$(NAME)-{{.OS}}-{{.Arch}}"

build_simple:
	# Building $(NAME) in version $(VERSION) for current platform
	go build \
		-ldflags "$(GO_LDFLAGS)" \
		-o "out/binaries/$(NAME)"

build_current: executors/docker/bindata.go build_simple

fmt:
	# Checking project code formatting...
	@go fmt ./... | awk '{ print "Please run go fmt"; exit 1 }'

vet:
	# Checking for suspicious constructs...
	@go vet ./...

lint:
	# Checking project code style...
	@golint ./... | ( ! grep -v -e "be unexported" -e "don't use an underscore in package name" -e "ALL_CAPS" )

complexity:
	# Checking code complexity
	@gocyclo -over 9 $(shell find . -name '*.go' | grep -v \
	    -e "/Godeps" \
	    -e "/helpers/shell_escape.go" \
	    -e "/executors/parallels/" \
	    -e "/executors/virtualbox/")

test: executors/docker/bindata.go
	# Running tests...
	@go test ./... -cover

install: executors/docker/bindata.go
	go install --ldflags="$(GO_LDFLAGS)"

dockerfiles:
	make -C dockerfiles all

mocks: FORCE
	go get github.com/vektra/mockery/.../
	rm -rf mocks/
	mockery -dir=$(GOPATH)/src/github.com/ayufan/golang-kardianos-service -name=Interface
	mockery -dir=./common -name=Network
	mockery -dir=./helpers/docker -name=Client

test-docker:
	make test-docker-image IMAGE=centos:6 TYPE=rpm
	make test-docker-image IMAGE=centos:7 TYPE=rpm
	make test-docker-image IMAGE=debian:wheezy TYPE=deb
	make test-docker-image IMAGE=debian:jessie TYPE=deb
	make test-docker-image IMAGE=ubuntu-upstart:precise TYPE=deb
	make test-docker-image IMAGE=ubuntu-upstart:trusty TYPE=deb
	make test-docker-image IMAGE=ubuntu-upstart:utopic TYPE=deb

test-docker-image:
	tests/test_installation.sh $(IMAGE) out/$(TYPE)/$(PACKAGE_NAME)_amd64.$(TYPE)
	tests/test_installation.sh $(IMAGE) out/$(TYPE)/$(PACKAGE_NAME)_amd64.$(TYPE) Y

build-and-deploy:
	make build BUILD_PLATFORMS="-os=linux -arch=amd64"
	make package-deb-fpm ARCH=amd64 PACKAGE_ARCH=amd64
	scp out/deb/$(PACKAGE_NAME)_amd64.deb $(SERVER):
	ssh $(SERVER) dpkg -i $(PACKAGE_NAME)_amd64.deb

build-and-deploy-binary:
	make build BUILD_PLATFORMS="-os=linux -arch=amd64"
	scp out/binaries/$(PACKAGE_NAME)-linux-amd64 $(SERVER):/usr/bin/gitlab-runner

package: package-deps package-deb package-rpm

package-deb:
	# Building Debian compatible packages...
	make package-deb-fpm ARCH=amd64 PACKAGE_ARCH=amd64
	make package-deb-fpm ARCH=386 PACKAGE_ARCH=i386
	make package-deb-fpm ARCH=arm PACKAGE_ARCH=arm
	make package-deb-fpm ARCH=arm PACKAGE_ARCH=armhf

package-rpm:
	# Building RedHat compatible packages...
	make package-rpm-fpm ARCH=amd64 PACKAGE_ARCH=amd64
	make package-rpm-fpm ARCH=386 PACKAGE_ARCH=i686
	make package-rpm-fpm ARCH=arm PACKAGE_ARCH=arm
	make package-rpm-fpm ARCH=arm PACKAGE_ARCH=armhf

package-deps:
	# Installing packaging dependencies...
	gem install fpm

package-deb-fpm:
	@mkdir -p out/deb/
	fpm -s dir -t deb -n $(PACKAGE_NAME) -v $(VERSION) \
		-p out/deb/$(PACKAGE_NAME)_$(PACKAGE_ARCH).deb \
		--deb-priority optional --category admin \
		--force \
		--deb-compression bzip2 \
		--after-install packaging/scripts/postinst.deb \
		--before-remove packaging/scripts/prerm.deb \
		--url https://gitlab.com/gitlab-org/gitlab-ci-multi-runner \
		--description "GitLab Runner" \
		-m "Kamil Trzciński <ayufan@ayufan.eu>" \
		--license "MIT" \
		--vendor "ayufan.eu" \
		--conflicts $(PACKAGE_CONFLICT) \
		--provides gitlab-runner \
		--replaces gitlab-runner \
		--depends ca-certificates \
		--depends git \
		--depends curl \
		--depends tar \
		--deb-suggests docker-engine \
		-a $(PACKAGE_ARCH) \
		packaging/root/=/ \
		out/binaries/$(NAME)-linux-$(ARCH)=/usr/bin/gitlab-ci-multi-runner

package-rpm-fpm:
	@mkdir -p out/rpm/
	fpm -s dir -t rpm -n $(PACKAGE_NAME) -v $(VERSION) \
		-p out/rpm/$(PACKAGE_NAME)_$(PACKAGE_ARCH).rpm \
		--rpm-compression bzip2 --rpm-os linux \
		--force \
		--after-install packaging/scripts/postinst.rpm \
		--before-remove packaging/scripts/prerm.rpm \
		--url https://gitlab.com/gitlab-org/gitlab-ci-multi-runner \
		--description "GitLab Runner" \
		-m "Kamil Trzciński <ayufan@ayufan.eu>" \
		--license "MIT" \
		--vendor "ayufan.eu" \
		--conflicts $(PACKAGE_CONFLICT) \
		--provides gitlab-runner \
		--replaces gitlab-runner \
		--depends git \
		--depends curl \
		--depends tar \
		-a $(PACKAGE_ARCH) \
		packaging/root/=/ \
		out/binaries/$(NAME)-linux-$(ARCH)=/usr/bin/gitlab-ci-multi-runner

packagecloud: packagecloud-deps packagecloud-deb packagecloud-rpm

packagecloud-deps:
	# Installing packagecloud dependencies...
	gem install package_cloud

packagecloud-deb:
	# Sending Debian compatible packages...
	-for DIST in $(DEB_PLATFORMS); do \
		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/deb/*.deb; \
	done

packagecloud-rpm:
	# Sending RedHat compatible packages...
	-for DIST in $(RPM_PLATFORMS); do \
		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/rpm/*.rpm; \
	done

packagecloud-yank:
ifneq ($(YANK),)
	# Removing $(YANK) from packagecloud...
	-for DIST in $(DEB_PLATFORMS); do \
		for ARCH in $(DEB_ARCHS); do \
			package_cloud yank --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST $(PACKAGE_NAME)_$(YANK)_$$ARCH.deb & \
		done; \
	done; \
	for DIST in $(RPM_PLATFORMS); do \
		for ARCH in $(RPM_ARCHS); do \
			package_cloud yank --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST $(PACKAGE_NAME)-$(YANK)-1.$$ARCH.rpm & \
		done; \
	done; \
	wait
else
	# No version specified in YANK
	@exit 1
endif

s3-upload:
	export ARTIFACTS_DEST=artifacts; curl -sL https://raw.githubusercontent.com/travis-ci/artifacts/master/install | bash
	./artifacts upload \

=== debian/changelog ===
gitlab-ci-multi-runner (1.4.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #833422).

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 08 Aug 2016 10:39:20 +1000

## gitlab-ci-multi-runner 1.4.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
     ubuntu/precise ubuntu/trusty ubuntu/utopic ubuntu/vivid ubuntu/wily ubuntu/xenial \
     raspbian/wheezy raspbian/jessie raspbian/stretch raspbian/buster \
     linuxmint/petra linuxmint/qiana linuxmint/rebecca linuxmint/rafaela linuxmint/rosa
-DEB_ARCHS ?= amd64 i386 arm armhf
+DEB_ARCHS ?= amd64 i386 armel armhf
 RPM_PLATFORMS ?= el/6 el/7 \
     ol/6 ol/7 \
     fedora/20 fedora/21 fedora/22 fedora/23
@@ -229,7 +229,7 @@
 	# Building Debian compatible packages...
 	make package-deb-fpm ARCH=amd64 PACKAGE_ARCH=amd64
 	make package-deb-fpm ARCH=386 PACKAGE_ARCH=i386
-	make package-deb-fpm ARCH=arm PACKAGE_ARCH=arm
+	make package-deb-fpm ARCH=arm PACKAGE_ARCH=armel
 	make package-deb-fpm ARCH=arm PACKAGE_ARCH=armhf
 
 package-rpm:

=== dockerfiles/Makefile ===
all: cache service

help:
	# make alpine
	# make cache
	# make dind
	# make service
	# make ubuntu

alpine: FORCE
	docker build -t gitlab/gitlab-runner:alpine alpine/

cache: FORCE
	docker build -t gitlab/gitlab-runner:cache cache/

dind: FORCE
	docker build -t gitlab/gitlab-runner:dind dind/

service: FORCE
	docker build -t gitlab/gitlab-runner:service service/

ubuntu: FORCE
	docker build -t gitlab/gitlab-runner:ubuntu ubuntu/
	docker tag gitlab/gitlab-runner:ubuntu  gitlab/gitlab-runner:latest

FORCE:

=== debian/changelog ===
gitlab-ci-multi-runner (1.4.2+dfsg-1) unstable; urgency=medium

  * New upstream release [August 2016].
  * Updated patch to fix TestBuildOptionsUnmarshaling instead of disabling it.
  * New patch to disable failing TestMachineLimitMax (Closes: #834459).

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 16 Aug 2016 10:43:16 +1000

=== debian/control ===
Source: gitlab-ci-multi-runner
Section: devel
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9) ,dh-golang ,dh-systemd
              ,golang-go
    ,golang-github-burntsushi-toml-dev
    ,golang-github-codegangsta-cli-dev
    ,golang-github-docker-docker-dev
    ,golang-github-fsouza-go-dockerclient-dev
    ,golang-github-getsentry-raven-go-dev
    ,golang-github-kardianos-osext-dev
    ,golang-github-minio-minio-go-dev
    ,golang-github-sirupsen-logrus-dev
    ,golang-github-stretchr-testify-dev
    ,golang-golang-x-crypto-dev
    ,golang-yaml.v2-dev
# tests:
    ,ca-certificates
    ,git
    ,golang-github-golang-mock-dev
Standards-Version: 3.9.8
Homepage: https://gitlab.com/gitlab-org/gitlab-ci-multi-runner/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/gitlab-ci-multi-runner.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/gitlab-ci-multi-runner.git
XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab-ci-multi-runner

Package: gitlab-ci-multi-runner
Provides: gitlab-runner
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends}
    ,adduser
    ,ca-certificates
#    ,curl
    ,git
Recommends: ${misc:Recommends}
    ,cdebootstrap
Suggests: ${misc:Suggests}
    ,docker.io
Description: GitLab Runner
 GitLab Runner runs tests and sends the results to GitLab.
 GitLab Continuous Integration (CI) service (included with GitLab)
 coordinates the testing.

=== debian/rules ===
#!/usr/bin/make -f

PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s*([\d\.]+)}')

export DH_GOPKG = gitlab.com/gitlab-org/gitlab-ci-multi-runner
export DH_GOPKG_common = $(DH_GOPKG)/common
#export DH_GOLANG_INSTALL_EXTRA := vendor
#export DH_GOLANG_INSTALL_ALL := 1
#export DH_GOLANG_EXCLUDES = apps/gitlab-runner-helper

## Set some build variables as per Makefile:
GO_LDFLAGS ?= \
    -X $(DH_GOPKG_common).NAME=$(PKG) \
    -X $(DH_GOPKG_common).REVISION=$(VER)
#    -X $(DH_GOPKG_common).VERSION=$(VERSION)
#    -X $(DH_GOPKG_common).BUILT=$(BUILT)
#    -X $(DH_GOPKG_common).BRANCH=$(BRANCH)

MKPI=debian/mk-prebuilt-images.sh

%:
	dh $@ --buildsystem=golang --with=golang,systemd --builddirectory=_build --paralel

override_dh_clean:
	dh_clean $(MKPI)
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
	-find Godeps -type d -empty -delete -print

$(MKPI):
	sed -e 's/__VERSION__/$(VER)/g' $@.in > $@
	chmod --reference=$@.in $@

override_dh_auto_configure: $(MKPI)
	dh_auto_configure
	cp -v --no-dereference vendor _build/src/gitlab.com/gitlab-org/gitlab-ci-multi-runner/

override_dh_auto_build:
	dh_auto_build --parallel -- \
            -ldflags "$(GO_LDFLAGS)"

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_auto_test:
	mkdir -v -p $(CURDIR)/debian/tmp
	HOME=$(CURDIR)/debian/tmp \
        dh_auto_test -- \
            -ldflags "$(GO_LDFLAGS)"

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://gitlab.com/gitlab-org/gitlab-ci-multi-runner/tags \
  .*archive\.tar\.gz\?ref=v?(\d\S*)

## gitlab-ci-multi-runner 1.7.1+dfsg

=== debian/changelog ===
gitlab-ci-multi-runner (1.7.1+dfsg-3) unstable; urgency=medium

  * Build-Depends += "golang-golang-x-oauth2-google-dev" (Closes: #844977).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 19 Nov 2016 23:30:26 +1100

gitlab-ci-multi-runner (1.7.1+dfsg-2) unstable; urgency=medium

  * mk-prebuilt-images.sh:
    + Capture verbose cdebootstrap logs.
    + "set -o pipefail" to properly abort on "set -e" when command is used
      with a pipe. This should prevent generating incomplete images on
      cdebootstrap errors.
    + Do not exclude packages (e2fsprogs, init) from pre-built image
      to fix image generation with cdebootstrap (>> 0.6.4).
      (Closes: #842380, #838011).

    Thanks, Vincent Danjean.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 14 Nov 2016 11:50:26 +1100

gitlab-ci-multi-runner (1.7.1+dfsg-1) unstable; urgency=medium

  * New upstream release [October 2016].
  * Build-Depends:
    + golang-github-gorhill-cronexpr-dev
  * Depends:
    + lsb-base
  * Dropped "test--offline.patch" and removed corresponding
    "executor_shell_test.go" due to build-time network access.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 27 Oct 2016 16:19:09 +1100

gitlab-ci-multi-runner (1.6.0+dfsg-1) unstable; urgency=medium

  * New upstream release [September 2016].
    - removed obsolete "ns-yaml-v2.patch".
  * Build-Depends:
    + golang-github-blang-semver-dev
    + golang-github-coreos-go-oidc-dev (>= 0.0~git20160926~)
    + golang-github-docker-distribution-dev
    + golang-github-docker-spdystream-dev
    + golang-github-emicklei-go-restful-dev
    + golang-github-ghodss-yaml-dev
    + golang-github-google-cadvisor-dev
    + golang-github-google-gofuzz-dev
    + golang-github-imdario-mergo-dev
    + golang-github-juju-ratelimit-dev
    + golang-github-pborman-uuid-dev
    + golang-github-spf13-pflag-dev
    + golang-gopkg-inf.v0-dev
  * mkimage: corrected regex for compatibility with older `awk`.
  * watch: ignore ~rc tags.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 27 Sep 2016 10:09:14 +1000

gitlab-ci-multi-runner (1.5.3+dfsg-1) unstable; urgency=medium

  * New upstream release [September 2016].
  * Introduced bug-presubj file.
  * mk-prebuilt-images.sh:
    + added "gitlab-runner-helper" to prebuilt image (Closes: #838012).
      Thanks, Bastian Blank.
    + optimised logging; save cdebootstrap log.
    + fixed detection of APT proxy when "squid-deb-proxy-client" is installed.
    + print detected proxy.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 18 Sep 2016 22:20:41 +1000

gitlab-ci-multi-runner (1.5.2+dfsg-1) unstable; urgency=medium

  * New upstream bugfix release [August 2016].

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 26 Aug 2016 10:49:17 +1000

gitlab-ci-multi-runner (1.5.0+dfsg-1) unstable; urgency=medium

  * New upstream release [August 2016].

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 25 Aug 2016 14:21:04 +1000

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,31 @@
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>
 Build-Depends: debhelper (>= 9) ,dh-golang ,dh-systemd
               ,golang-go
+    ,golang-github-blang-semver-dev
     ,golang-github-burntsushi-toml-dev
     ,golang-github-codegangsta-cli-dev
+    ,golang-github-coreos-go-oidc-dev (>= 0.0~git20160926~)
     ,golang-github-docker-docker-dev
+    ,golang-github-docker-distribution-dev
+    ,golang-github-docker-spdystream-dev
     ,golang-github-fsouza-go-dockerclient-dev
+    ,golang-github-emicklei-go-restful-dev
     ,golang-github-getsentry-raven-go-dev
+    ,golang-github-ghodss-yaml-dev
+    ,golang-github-google-cadvisor-dev
+    ,golang-github-google-gofuzz-dev
+    ,golang-github-gorhill-cronexpr-dev
+    ,golang-github-imdario-mergo-dev
+    ,golang-github-juju-ratelimit-dev
     ,golang-github-kardianos-osext-dev
     ,golang-github-minio-minio-go-dev
+    ,golang-github-pborman-uuid-dev
     ,golang-github-sirupsen-logrus-dev
+    ,golang-github-spf13-pflag-dev
     ,golang-github-stretchr-testify-dev
     ,golang-golang-x-crypto-dev
+    ,golang-golang-x-oauth2-google-dev
+    ,golang-gopkg-inf.v0-dev
     ,golang-yaml.v2-dev
 # tests:
     ,ca-certificates
@@ -36,6 +51,7 @@
     ,ca-certificates
 #    ,curl
     ,git
+    ,lsb-base
 Recommends: ${misc:Recommends}
     ,cdebootstrap
 Suggests: ${misc:Suggests}

## gitlab-ci-multi-runner 1.8.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,16 +1,17 @@
 NAME ?= gitlab-ci-multi-runner
 PACKAGE_NAME ?= $(NAME)
 PACKAGE_CONFLICT ?= $(PACKAGE_NAME)-beta
+VERSION := $(shell ./ci/version)
 REVISION := $(shell git rev-parse --short HEAD || echo unknown)
-LAST_TAG := $(shell git describe --tags --abbrev=0)
-COMMITS := $(shell echo `git log --oneline $(LAST_TAG)..HEAD | wc -l`)
-VERSION := $(shell (cat VERSION || echo dev) | sed -e 's/^v//g')
+BRANCH := $(shell git show-ref | grep "$(REVISION)" | grep -v HEAD | awk '{print $$2}' | sed 's|refs/remotes/origin/||' | sed 's|refs/heads/||' | sort | head -n 1)
 BUILT := $(shell date +%Y-%m-%dT%H:%M:%S%:z)
-ifneq ($(RELEASE),true)
-    VERSION := $(shell echo $(VERSION)~beta.$(COMMITS).g$(REVISION))
+
+LATEST_STABLE_TAG := $(shell git -c versionsort.prereleaseSuffix="-rc" -c versionsort.prereleaseSuffix="-RC" tag -l "v*.*.*" --sort=-v:refname | awk '!/rc/' | head -n 1)
+export IS_LATEST :=
+ifeq ($(shell git describe --exact-match --match $(LATEST_STABLE_TAG) >/dev/null 2>&1; echo $$?), 0)
+export IS_LATEST := true
 endif
-BRANCH := $(shell git show-ref | grep "$(REVISION)" | grep -v HEAD | awk '{print $$2}' | sed 's|refs/remotes/origin/||' | sed 's|refs/heads/||' | sort | head -n 1)
-ITTERATION := $(shell date +%s)
+
 PACKAGE_CLOUD ?= ayufan/gitlab-ci-multi-runner
 PACKAGE_CLOUD_URL ?= https://packagecloud.io/
 BUILD_PLATFORMS ?= -os '!netbsd' -os '!openbsd'
@@ -25,11 +26,15 @@
     fedora/20 fedora/21 fedora/22 fedora/23
 RPM_ARCHS ?= x86_64 i686 arm armhf
 COMMON_PACKAGE_NAMESPACE=$(shell go list ./common)
+
+# Packages in vendor/ are included in ./...
+# https://github.com/golang/go/issues/11659
+OUR_PACKAGES=$(shell go list ./... | grep -v '/vendor/')
+
 GO_LDFLAGS ?= -X $(COMMON_PACKAGE_NAMESPACE).NAME=$(PACKAGE_NAME) -X $(COMMON_PACKAGE_NAMESPACE).VERSION=$(VERSION) \
               -X $(COMMON_PACKAGE_NAMESPACE).REVISION=$(REVISION) -X $(COMMON_PACKAGE_NAMESPACE).BUILT=$(BUILT) \
               -X $(COMMON_PACKAGE_NAMESPACE).BRANCH=$(BRANCH)
 GO_FILES ?= $(shell find . -name '*.go')
-export GO15VENDOREXPERIMENT := 1
 export CGO_ENABLED := 0
 
 all: deps verify build
@@ -60,13 +65,12 @@
 
 version: FORCE
 	@echo Current version: $(VERSION)
-	@echo Current iteration: $(ITTERATION)
 	@echo Current revision: $(REVISION)
 	@echo Current branch: $(BRANCH)
 	@echo Build platforms: $(BUILD_PLATFORMS)
 	@echo DEB platforms: $(DEB_PLATFORMS)
 	@echo RPM platforms: $(RPM_PLATFORMS)
-	bash -c 'echo TEST: ${GO15VENDOREXPERIMENT}'
+	@echo IS_LATEST: $(IS_LATEST)
 
 verify: fmt vet lint complexity test
 
@@ -79,7 +83,7 @@
 	go get -u github.com/jteeuwen/go-bindata/...
 	go install cmd/vet
 
-out/docker/prebuilt-x86_64.tar.gz: $(GO_FILES)
+out/docker/prebuilt-x86_64.tar.xz: $(GO_FILES)
 	# Create directory
 	mkdir -p out/docker
 
@@ -96,18 +100,18 @@
 	docker create --name=gitlab-runner-prebuilt-x86_64-$(REVISION) gitlab-runner-prebuilt-x86_64:$(REVISION) /bin/sh
 	docker export -o out/docker/prebuilt-x86_64.tar gitlab-runner-prebuilt-x86_64-$(REVISION)
 	docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
-	gzip -f -9 out/docker/prebuilt-x86_64.tar
+	xz -f -9 out/docker/prebuilt-x86_64.tar
 else
 	$(warning =============================================)
 	$(warning WARNING: downloading prebuilt docker images that will be embedded in gitlab-runner)
 	$(warning WARNING: to use images compiled from your code install Docker Engine)
-	$(warning WARNING: and remove out/docker/prebuilt-x86_64.tar.gz)
+	$(warning WARNING: and remove out/docker/prebuilt-x86_64.tar.xz)
 	$(warning =============================================)
-	curl -o out/docker/prebuilt-x86_64.tar.gz \
-		https://gitlab-ci-multi-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-x86_64.tar.gz
+	curl -o out/docker/prebuilt-x86_64.tar.xz \
+		https://gitlab-ci-multi-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-x86_64.tar.xz
 endif
 
-out/docker/prebuilt-arm.tar.gz: $(GO_FILES)
+out/docker/prebuilt-arm.tar.xz: $(GO_FILES)
 	# Create directory
 	mkdir -p out/docker
 
@@ -124,18 +128,18 @@
 	docker create --name=gitlab-runner-prebuilt-arm-$(REVISION) gitlab-runner-prebuilt-arm:$(REVISION) /bin/sh
 	docker export -o out/docker/prebuilt-arm.tar gitlab-runner-prebuilt-arm-$(REVISION)
 	docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
-	gzip -f -9 out/docker/prebuilt-arm.tar
+	xz -f -9 out/docker/prebuilt-arm.tar
 else
 	$(warning =============================================)
 	$(warning WARNING: downloading prebuilt docker images that will be embedded in gitlab-runner)
 	$(warning WARNING: to use images compiled from your code install Docker Engine)
-	$(warning WARNING: and remove out/docker/prebuilt-arm.tar.gz)
+	$(warning WARNING: and remove out/docker/prebuilt-arm.tar.xz)
 	$(warning =============================================)
-	curl -o out/docker/prebuilt-arm.tar.gz \
-		https://gitlab-ci-multi-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-arm.tar.gz
+	curl -o out/docker/prebuilt-arm.tar.xz \
+		https://gitlab-ci-multi-runner-downloads.s3.amazonaws.com/master/docker/prebuilt-arm.tar.xz
 endif
 
-executors/docker/bindata.go: out/docker/prebuilt-x86_64.tar.gz out/docker/prebuilt-arm.tar.gz
+executors/docker/bindata.go: out/docker/prebuilt-x86_64.tar.xz out/docker/prebuilt-arm.tar.xz
 	# Generating embedded data
 	go-bindata \
 		-pkg docker \
@@ -144,8 +148,9 @@
 		-nometadata \
 		-prefix out/docker/ \
 		-o executors/docker/bindata.go \
-		out/docker/prebuilt-x86_64.tar.gz \
-		out/docker/prebuilt-arm.tar.gz
+		out/docker/prebuilt-x86_64.tar.xz \
+		out/docker/prebuilt-arm.tar.xz
+	go fmt executors/docker/bindata.go
 
 docker: executors/docker/bindata.go
 
@@ -165,27 +170,29 @@
 
 fmt:
 	# Checking project code formatting...
-	@go fmt ./... | awk '{ print "Please run go fmt"; exit 1 }'
+	@go fmt $(OUR_PACKAGES) | awk '{if (NF > 0) {if (NR == 1) print "Please run go fmt for:"; print "- "$$1}} END {if (NF > 0) {if (NR > 0) exit 1}}'
 
 vet:
 	# Checking for suspicious constructs...
-	@go vet ./...
+	@go vet $(OUR_PACKAGES)
 
 lint:
 	# Checking project code style...
-	@golint ./... | ( ! grep -v -e "be unexported" -e "don't use an underscore in package name" -e "ALL_CAPS" )
+	@golint ./... | ( ! grep -v -e "^vendor/" -e "be unexported" -e "don't use an underscore in package name" -e "ALL_CAPS" )
 
 complexity:
 	# Checking code complexity
-	@gocyclo -over 9 $(shell find . -name '*.go' | grep -v \
-	    -e "/Godeps" \
+	@gocyclo -over 9 $(shell find . -name '*.go' -not -path './vendor/*' | grep -v \
 	    -e "/helpers/shell_escape.go" \
+			-e "/executors/kubernetes/executor_kubernetes_test.go" \
+			-e "/executors/kubernetes/util_test.go" \
+			-e "/executors/kubernetes/exec_test.go" \
 	    -e "/executors/parallels/" \
 	    -e "/executors/virtualbox/")
 
 test: executors/docker/bindata.go
 	# Running tests...
-	@go test ./... -cover
+	@go test $(OUR_PACKAGES) -cover
 
 install: executors/docker/bindata.go
 	go install --ldflags="$(GO_LDFLAGS)"
@@ -195,10 +202,11 @@
 
 mocks: FORCE
 	go get github.com/vektra/mockery/.../
-	rm -rf mocks/
-	mockery -dir=$(GOPATH)/src/github.com/ayufan/golang-kardianos-service -name=Interface
-	mockery -dir=./common -name=Network
-	mockery -dir=./helpers/docker -name=Client
+	rm -rf ./mocks ./helpers/docker/mocks ./common/mocks ./helpers/service/mocks
+	find . -type f -name 'mock_*' -delete
+	mockery -dir=$(GOPATH)/src/github.com/ayufan/golang-kardianos-service -output=./helpers/service/mocks -name=Interface
+	mockery -dir=./common -all -inpkg
+	mockery -dir=./helpers/docker -all -inpkg
 
 test-docker:
 	make test-docker-image IMAGE=centos:6 TYPE=rpm
@@ -315,20 +323,3 @@
 	# Removing $(YANK) from packagecloud...
 	-for DIST in $(DEB_PLATFORMS); do \
 		for ARCH in $(DEB_ARCHS); do \
-			package_cloud yank --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST $(PACKAGE_NAME)_$(YANK)_$$ARCH.deb & \
-		done; \
-	done; \
-	for DIST in $(RPM_PLATFORMS); do \
-		for ARCH in $(RPM_ARCHS); do \
-			package_cloud yank --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST $(PACKAGE_NAME)-$(YANK)-1.$$ARCH.rpm & \
-		done; \
-	done; \
-	wait
-else
-	# No version specified in YANK
-	@exit 1
-endif
-
-s3-upload:
-	export ARTIFACTS_DEST=artifacts; curl -sL https://raw.githubusercontent.com/travis-ci/artifacts/master/install | bash
-	./artifacts upload \

=== debian/changelog ===
gitlab-ci-multi-runner (1.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release [November 2016].
  * Build-Depends += "golang-github-prometheus-client-golang-dev".
  * Build-Depends on "golang-go (>= 2:1.7~)".
  * New "nopull_prebuilt.patch" to prevent attempts to pull prebuilt image.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 30 Nov 2016 17:24:29 +1100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>
 Build-Depends: debhelper (>= 9) ,dh-golang ,dh-systemd
-              ,golang-go
+              ,golang-go (>= 2:1.7~)
     ,golang-github-blang-semver-dev
     ,golang-github-burntsushi-toml-dev
     ,golang-github-codegangsta-cli-dev
@@ -24,6 +24,7 @@
     ,golang-github-kardianos-osext-dev
     ,golang-github-minio-minio-go-dev
     ,golang-github-pborman-uuid-dev
+    ,golang-github-prometheus-client-golang-dev
     ,golang-github-sirupsen-logrus-dev
     ,golang-github-spf13-pflag-dev
     ,golang-github-stretchr-testify-dev

=== debian/rules ===
--- 
+++ 
@@ -35,7 +35,6 @@
 
 override_dh_auto_configure: $(MKPI)
 	dh_auto_configure
-	cp -v --no-dereference vendor _build/src/gitlab.com/gitlab-org/gitlab-ci-multi-runner/
 
 override_dh_auto_build:
 	dh_auto_build --parallel -- \
@@ -49,3 +48,4 @@
 	HOME=$(CURDIR)/debian/tmp \
         dh_auto_test -- \
             -ldflags "$(GO_LDFLAGS)"
+#-test.short

## gitlab-ci-multi-runner 1.8.1+dfsg

=== debian/changelog ===
gitlab-ci-multi-runner (1.8.1+dfsg-1) unstable; urgency=medium

  * New upstream release [November 2016].

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 02 Dec 2016 11:16:31 +1100

## gitlab-ci-multi-runner 1.9.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -95,9 +95,9 @@
 		./apps/gitlab-runner-helper
 
 	# Build docker images
-	docker build -t gitlab-runner-prebuilt-x86_64:$(REVISION) -f dockerfiles/build/Dockerfile.x86_64 dockerfiles/build
+	docker build -t gitlab/gitlab-runner-helper:x86_64-$(REVISION) -f dockerfiles/build/Dockerfile.x86_64 dockerfiles/build
 	-docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
-	docker create --name=gitlab-runner-prebuilt-x86_64-$(REVISION) gitlab-runner-prebuilt-x86_64:$(REVISION) /bin/sh
+	docker create --name=gitlab-runner-prebuilt-x86_64-$(REVISION) gitlab/gitlab-runner-helper:x86_64-$(REVISION) /bin/sh
 	docker export -o out/docker/prebuilt-x86_64.tar gitlab-runner-prebuilt-x86_64-$(REVISION)
 	docker rm -f gitlab-runner-prebuilt-x86_64-$(REVISION)
 	xz -f -9 out/docker/prebuilt-x86_64.tar
@@ -123,9 +123,9 @@
 		./apps/gitlab-runner-helper
 
 	# Build docker images
-	docker build -t gitlab-runner-prebuilt-arm:$(REVISION) -f dockerfiles/build/Dockerfile.arm dockerfiles/build
+	docker build -t gitlab/gitlab-runner-helper:arm-$(REVISION) -f dockerfiles/build/Dockerfile.arm dockerfiles/build
 	-docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
-	docker create --name=gitlab-runner-prebuilt-arm-$(REVISION) gitlab-runner-prebuilt-arm:$(REVISION) /bin/sh
+	docker create --name=gitlab-runner-prebuilt-arm-$(REVISION) gitlab/gitlab-runner-helper:arm-$(REVISION) /bin/sh
 	docker export -o out/docker/prebuilt-arm.tar gitlab-runner-prebuilt-arm-$(REVISION)
 	docker rm -f gitlab-runner-prebuilt-arm-$(REVISION)
 	xz -f -9 out/docker/prebuilt-arm.tar

=== debian/changelog ===
gitlab-ci-multi-runner (1.9.2+dfsg-1) unstable; urgency=medium

  * New upstream release [January 2017].
  * Install "/usr/share/gitlab-runner/clear-docker-cache" script.
  * Enabled build tests by faking git repository.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 10 Jan 2017 17:51:16 +1100

## gitlab-ci-multi-runner 1.10.3+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 NAME ?= gitlab-ci-multi-runner
 PACKAGE_NAME ?= $(NAME)
 PACKAGE_CONFLICT ?= $(PACKAGE_NAME)-beta
-VERSION := $(shell ./ci/version)
+export VERSION := $(shell ./ci/version)
 REVISION := $(shell git rev-parse --short HEAD || echo unknown)
 BRANCH := $(shell git show-ref | grep "$(REVISION)" | grep -v HEAD | awk '{print $$2}' | sed 's|refs/remotes/origin/||' | sed 's|refs/heads/||' | sort | head -n 1)
 BUILT := $(shell date +%Y-%m-%dT%H:%M:%S%:z)
@@ -17,7 +17,7 @@
 BUILD_PLATFORMS ?= -os '!netbsd' -os '!openbsd'
 S3_UPLOAD_PATH ?= master
 DEB_PLATFORMS ?= debian/wheezy debian/jessie debian/stretch debian/buster \
-    ubuntu/precise ubuntu/trusty ubuntu/utopic ubuntu/vivid ubuntu/wily ubuntu/xenial \
+    ubuntu/precise ubuntu/trusty ubuntu/utopic ubuntu/vivid ubuntu/wily ubuntu/xenial ubuntu/yakkety \
     raspbian/wheezy raspbian/jessie raspbian/stretch raspbian/buster \
     linuxmint/petra linuxmint/qiana linuxmint/rebecca linuxmint/rafaela linuxmint/rosa
 DEB_ARCHS ?= amd64 i386 armel armhf
@@ -231,7 +231,14 @@
 	make build BUILD_PLATFORMS="-os=linux -arch=amd64"
 	scp out/binaries/$(PACKAGE_NAME)-linux-amd64 $(SERVER):/usr/bin/gitlab-runner
 
-package: package-deps package-deb package-rpm
+package: package-deps package-prepare package-deb package-rpm
+
+package-deps:
+	# Installing packaging dependencies...
+	gem install fpm
+
+package-prepare:
+	chmod 755 packaging/root/usr/share/gitlab-runner/*
 
 package-deb:
 	# Building Debian compatible packages...
@@ -246,10 +253,6 @@
 	make package-rpm-fpm ARCH=386 PACKAGE_ARCH=i686
 	make package-rpm-fpm ARCH=arm PACKAGE_ARCH=arm
 	make package-rpm-fpm ARCH=arm PACKAGE_ARCH=armhf
-
-package-deps:
-	# Installing packaging dependencies...
-	gem install fpm
 
 package-deb-fpm:
 	@mkdir -p out/deb/
@@ -320,6 +323,3 @@
 
 packagecloud-yank:
 ifneq ($(YANK),)
-	# Removing $(YANK) from packagecloud...
-	-for DIST in $(DEB_PLATFORMS); do \
-		for ARCH in $(DEB_ARCHS); do \

=== debian/changelog ===
gitlab-ci-multi-runner (1.10.3+dfsg-1) unstable; urgency=medium

  * New upstream release [January 2017].

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 31 Jan 2017 16:35:21 +1100

## gitlab-ci-multi-runner 1.11.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -17,13 +17,13 @@
 BUILD_PLATFORMS ?= -os '!netbsd' -os '!openbsd'
 S3_UPLOAD_PATH ?= master
 DEB_PLATFORMS ?= debian/wheezy debian/jessie debian/stretch debian/buster \
-    ubuntu/precise ubuntu/trusty ubuntu/utopic ubuntu/vivid ubuntu/wily ubuntu/xenial ubuntu/yakkety \
+    ubuntu/precise ubuntu/trusty ubuntu/utopic ubuntu/vivid ubuntu/wily ubuntu/xenial ubuntu/yakkety ubuntu/zesty \
     raspbian/wheezy raspbian/jessie raspbian/stretch raspbian/buster \
-    linuxmint/petra linuxmint/qiana linuxmint/rebecca linuxmint/rafaela linuxmint/rosa
+    linuxmint/petra linuxmint/qiana linuxmint/rebecca linuxmint/rafaela linuxmint/rosa linuxmint/sarah linuxmint/serena
 DEB_ARCHS ?= amd64 i386 armel armhf
 RPM_PLATFORMS ?= el/6 el/7 \
     ol/6 ol/7 \
-    fedora/20 fedora/21 fedora/22 fedora/23
+    fedora/20 fedora/21 fedora/22 fedora/23 fedora/24 fedora/25
 RPM_ARCHS ?= x86_64 i686 arm armhf
 COMMON_PACKAGE_NAMESPACE=$(shell go list ./common)
 
@@ -238,6 +238,7 @@
 	gem install fpm
 
 package-prepare:
+	chmod 755 packaging/root/usr/share/gitlab-runner/
 	chmod 755 packaging/root/usr/share/gitlab-runner/*
 
 package-deb:
@@ -265,9 +266,9 @@
 		--before-remove packaging/scripts/prerm.deb \
 		--url https://gitlab.com/gitlab-org/gitlab-ci-multi-runner \
 		--description "GitLab Runner" \
-		-m "Kamil Trzciński <ayufan@ayufan.eu>" \
+		-m "GitLab Inc. <support@gitlab.com>" \
 		--license "MIT" \
-		--vendor "ayufan.eu" \
+		--vendor "GitLab Inc." \
 		--conflicts $(PACKAGE_CONFLICT) \
 		--provides gitlab-runner \
 		--replaces gitlab-runner \
@@ -290,9 +291,9 @@
 		--before-remove packaging/scripts/prerm.rpm \
 		--url https://gitlab.com/gitlab-org/gitlab-ci-multi-runner \
 		--description "GitLab Runner" \
-		-m "Kamil Trzciński <ayufan@ayufan.eu>" \
+		-m "GitLab Inc. <support@gitlab.com>" \
 		--license "MIT" \
-		--vendor "ayufan.eu" \
+		--vendor "GitLab Inc." \
 		--conflicts $(PACKAGE_CONFLICT) \
 		--provides gitlab-runner \
 		--replaces gitlab-runner \
@@ -318,8 +319,3 @@
 packagecloud-rpm:
 	# Sending RedHat compatible packages...
 	-for DIST in $(RPM_PLATFORMS); do \
-		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/rpm/*.rpm; \
-	done
-
-packagecloud-yank:
-ifneq ($(YANK),)

=== debian/changelog ===
gitlab-ci-multi-runner (1.11.1+dfsg-1) unstable; urgency=medium

  * New upstream release [March 2017].
  * New "kubernetes.patch" to fix FTBFS with runc v1.0.0.
  * Updated "test--fixcompare.patch".

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 09 Mar 2017 19:03:53 +1100

## gitlab-ci-multi-runner 1.11.4+dfsg

=== Makefile ===
--- 
+++ 
@@ -72,7 +72,9 @@
 	@echo RPM platforms: $(RPM_PLATFORMS)
 	@echo IS_LATEST: $(IS_LATEST)
 
-verify: fmt vet lint complexity test
+verify: static_code_analysis test
+
+static_code_analysis: fmt vet lint complexity
 
 deps:
 	# Installing dependencies...
@@ -235,20 +237,20 @@
 
 package-deps:
 	# Installing packaging dependencies...
-	gem install fpm
+	gem install fpm --no-ri --no-rdoc
 
 package-prepare:
 	chmod 755 packaging/root/usr/share/gitlab-runner/
 	chmod 755 packaging/root/usr/share/gitlab-runner/*
 
-package-deb:
+package-deb: package-deps package-prepare
 	# Building Debian compatible packages...
 	make package-deb-fpm ARCH=amd64 PACKAGE_ARCH=amd64
 	make package-deb-fpm ARCH=386 PACKAGE_ARCH=i386
 	make package-deb-fpm ARCH=arm PACKAGE_ARCH=armel
 	make package-deb-fpm ARCH=arm PACKAGE_ARCH=armhf
 
-package-rpm:
+package-rpm: package-deps package-prepare
 	# Building RedHat compatible packages...
 	make package-rpm-fpm ARCH=amd64 PACKAGE_ARCH=amd64
 	make package-rpm-fpm ARCH=386 PACKAGE_ARCH=i686
@@ -308,14 +310,8 @@
 
 packagecloud-deps:
 	# Installing packagecloud dependencies...
-	gem install package_cloud
+	gem install package_cloud --no-ri --no-rdoc
 
 packagecloud-deb:
 	# Sending Debian compatible packages...
 	-for DIST in $(DEB_PLATFORMS); do \
-		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/deb/*.deb; \
-	done
-
-packagecloud-rpm:
-	# Sending RedHat compatible packages...
-	-for DIST in $(RPM_PLATFORMS); do \

=== debian/changelog ===
gitlab-ci-multi-runner (1.11.4+dfsg-2) unstable; urgency=medium

  * New "swagger.patch" to fix FTBFS (Closes: #871078).
  * Build-Depends:
    * golang-github-emicklei-go-restful-dev (>=2.4.0~)
    + golang-github-emicklei-go-restful-swagger12-dev
    - golang-github-opencontainers-runc-dev
    + golang-github-opencontainers-docker-runc-dev
  * Standards-Version: 4.1.1; Priority: optional.
  * Debhelper/compat to version 10.
  * Updated project URL.
  * rules: removed calls to `dpkg-parsechangelog`.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 19 Oct 2017 01:42:19 +1100

gitlab-ci-multi-runner (1.11.4+dfsg-1) unstable; urgency=medium

  * New upstream release [April 2017].
  * Build-Depends += "golang-github-opencontainers-runc-dev (>=1.0.0~)".

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 24 May 2017 07:23:14 +1000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: gitlab-ci-multi-runner
 Section: devel
-Priority: extra
+Priority: optional
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>
-Build-Depends: debhelper (>= 9) ,dh-golang ,dh-systemd
+Build-Depends: debhelper (>= 10) ,dh-golang
               ,golang-go (>= 2:1.7~)
     ,golang-github-blang-semver-dev
     ,golang-github-burntsushi-toml-dev
@@ -13,7 +13,8 @@
     ,golang-github-docker-distribution-dev
     ,golang-github-docker-spdystream-dev
     ,golang-github-fsouza-go-dockerclient-dev
-    ,golang-github-emicklei-go-restful-dev
+    ,golang-github-emicklei-go-restful-dev (>=2.4.0~)
+    ,golang-github-emicklei-go-restful-swagger12-dev
     ,golang-github-getsentry-raven-go-dev
     ,golang-github-ghodss-yaml-dev
     ,golang-github-google-cadvisor-dev
@@ -23,6 +24,7 @@
     ,golang-github-juju-ratelimit-dev
     ,golang-github-kardianos-osext-dev
     ,golang-github-minio-minio-go-dev
+    ,golang-github-opencontainers-docker-runc-dev (>=1.0.0~)
     ,golang-github-pborman-uuid-dev
     ,golang-github-prometheus-client-golang-dev
     ,golang-github-sirupsen-logrus-dev
@@ -36,8 +38,8 @@
     ,ca-certificates
     ,git
     ,golang-github-golang-mock-dev
-Standards-Version: 3.9.8
-Homepage: https://gitlab.com/gitlab-org/gitlab-ci-multi-runner/
+Standards-Version: 4.1.1
+Homepage: https://gitlab.com/gitlab-org/gitlab-runner/
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/gitlab-ci-multi-runner.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/gitlab-ci-multi-runner.git
 XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab-ci-multi-runner

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,9 @@
 #!/usr/bin/make -f
 
-PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
-PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
-VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s*([\d\.]+)}')
+include /usr/share/dpkg/pkg-info.mk
+
+VER ?= $(shell printf $(DEB_VERSION_UPSTREAM) | perl -ne 'print $$1 if m{^([\d\.]+)}')
+$(info DEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM) VER=$(VER))
 
 export DH_GOPKG = gitlab.com/gitlab-org/gitlab-ci-multi-runner
 export DH_GOPKG_common = $(DH_GOPKG)/common
@@ -12,7 +13,7 @@
 
 ## Set some build variables as per Makefile:
 GO_LDFLAGS ?= \
-    -X $(DH_GOPKG_common).NAME=$(PKG) \
+    -X $(DH_GOPKG_common).NAME=$(DEB_SOURCE) \
     -X $(DH_GOPKG_common).REVISION=$(VER)
 #    -X $(DH_GOPKG_common).VERSION=$(VERSION)
 #    -X $(DH_GOPKG_common).BUILT=$(BUILT)
@@ -33,7 +34,12 @@
 	sed -e 's/__VERSION__/$(VER)/g' $@.in > $@
 	chmod --reference=$@.in $@
 
-override_dh_auto_configure: $(MKPI)
+GITDIR=_build/src/$(DH_GOPKG)/tmp/gitlab-test
+$(GITDIR):
+	mkdir -v -p $@
+	cd $@ && git init
+
+override_dh_auto_configure: $(MKPI) $(GITDIR)
 	dh_auto_configure
 
 override_dh_auto_build:

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://gitlab.com/gitlab-org/gitlab-runner/tags \
  .*archive\.tar\.gz\?ref=v?(\d[\.\d]*)

## gitlab-ci-multi-runner 10.5.0%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,10 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/pkg-info.mk
+VER  ?= $(shell sh -c 'printf "$${1%%+dfsg*}"' -- "$(DEB_VERSION_UPSTREAM)")
 
-VER ?= $(shell printf $(DEB_VERSION_UPSTREAM) | perl -ne 'print $$1 if m{^([\d\.]+)}')
-$(info DEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM) VER=$(VER))
-
-export DH_GOPKG = gitlab.com/gitlab-org/gitlab-ci-multi-runner
+export DH_GOLANG_GO_GENERATE := 1
+export DH_GOPKG = gitlab.com/gitlab-org/gitlab-runner
 export DH_GOPKG_common = $(DH_GOPKG)/common
 #export DH_GOLANG_INSTALL_EXTRA := vendor
 #export DH_GOLANG_INSTALL_ALL := 1
@@ -13,22 +12,23 @@
 
 ## Set some build variables as per Makefile:
 GO_LDFLAGS ?= \
-    -X $(DH_GOPKG_common).NAME=$(DEB_SOURCE) \
+    -X $(DH_GOPKG_common).VERSION=$(VER) \
     -X $(DH_GOPKG_common).REVISION=$(VER)
-#    -X $(DH_GOPKG_common).VERSION=$(VERSION)
+#    -X $(DH_GOPKG_common).NAME=$(DEB_SOURCE)
 #    -X $(DH_GOPKG_common).BUILT=$(BUILT)
 #    -X $(DH_GOPKG_common).BRANCH=$(BRANCH)
 
 MKPI=debian/mk-prebuilt-images.sh
 
 %:
-	dh $@ --buildsystem=golang --with=golang,systemd --builddirectory=_build --paralel
+	dh $@ --buildsystem=golang --with=golang --builddirectory=_build
 
 override_dh_clean:
 	dh_clean $(MKPI)
 	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
 	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
-	-find Godeps -type d -empty -delete -print
+	-find vendor -type d -empty -delete -print
+	-find . -type f -name '*.generated.go' -print -delete ## delete .generated.go files
 
 $(MKPI):
 	sed -e 's/__VERSION__/$(VER)/g' $@.in > $@
